source("functioncollection.R")
data <- dget("data.out")
 
#Pathway name: ADP-Ribosylation Factor pathway
##lets start to fit data
## tuning parameter selection
z<- data$z
truestructure <- data$true

evec <- 5*10^{seq(-5,3, by=1)}
a<- try(cvres1 <- gcv1(z=z, evec=evec))
if(class(a)!="tryerror"){
  (epsilon1 <- evec[which(cvres1 == min(cvres1))])
}else{
   a<- try(cvres1 <- gcv1(z=z, evec=evec, LINPACK=TRUE))
   (epsilon1 <- evec[which(cvres1 == min(cvres1))]) 
}

a<- try(cvres2 <- gcv2(z=z, evec=evec))

if(class(a)!="tryerror"){
  epsilon2 <- evec[which(cvres2 == min(cvres2))]
}else{
  a<- try(cvres2 <- gcv2(z=z, evec=evec, LINPACK=TRUE))
  epsilon2 <- evec[which(cvres2 == min(cvres2))]
}

##ACCO
est.precision <- fit.asg(z=z, epsilon1=epsilon1, epsilon2=epsilon2)$asg

##thresholding
vlambda = sort(c((c(unique(abs(est.precision)))),seq(0.0001,1, length=max(1,1000-length(unique(est.precision)),1) )))
est <- threshold.est(est.precision=est.precision, vlambda =vlambda)


##APO
a<- try(  est.precision2 <- fit.asg2(z=z, epsilon1=epsilon1, epsilon2=epsilon2)$asg)

if(class(a)=="try-error"){
  est.precision2 <- fit.asg2(z=z, epsilon1=epsilon1, epsilon2=epsilon2, LINPACK=TRUE)$asg
}
mm <- max(abs(est.precision2))
diag(est.precision2) <- mm+0.1
vlambda = sort(c((c(unique(abs(est.precision2)))),seq(0,mm+0.1, length=max(1000-length(unique(est.precision2)),1 ))))
est2 <- threshold.est(est.precision=est.precision2, vlambda =vlambda)


##GCGM and GGM
vlambda.length=1000
lambda.vec=10^seq(-3,1,length=vlambda.length) #

est.rho  <- est.corr <- list()
for(j in 1:vlambda.length){
  lambda <- lambda.vec[j] #fix lambda
  est.rho[[j]] <- fit.rho(z=z, lambda=lambda, adaptive=FALSE)
  est.corr[[j]] <- fit.regular(z=z, lambda=lambda, adaptive=FALSE)
}

p=dim(z)[2]

(a<-computeROC(est, vlambda.length=length(vlambda), true=truestructure))
(b<-computeROC(est2, vlambda.length=length(vlambda), true=truestructure))
(c<-computeROC(est=est.rho, vlambda.length=vlambda.length, true=truestructure))
(e<- computeROC(est=est.corr, vlambda.length=vlambda.length, true=truestructure))  

print(c(computeAUC(a), computeAUC(b),computeAUC(c), computeAUC(e)))
